import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
//
public class Oberflaeche extends JFrame { // Das ist der Fensterrahmen des Programms
  private Steuerung dieSteuerung = new Steuerung(); // Die Steuerung ist eine extra Klasse
 
  public Oberflaeche() {
    System.out.println("Oberflaeche Konstruktor");  
    getContentPane().add(new MyContainer(dieSteuerung)); // Den Container in den Fensterrahmen eingebaut
    setDefaultCloseOperation( JFrame.EXIT_ON_CLOSE ); // Beenden wenn Rahmen geschlossen 
    System.out.println("Oberflaeche Konstruktor Ende");  
  }
  
  public static void main(String[] args) { // Main Methode zum starten der Applikation
    System.out.println("Oberflaeche main");    
    Oberflaeche dieOberflaeche = new Oberflaeche();   // Das Fenster wird erzeugt
    dieOberflaeche.setSize(500,500);                  // Die Groesse wird festgelegt
    dieOberflaeche.setTitle("Verkaufsautomat 2.0 Plapper (c) MezMedia '2021");
    dieOberflaeche.setVisible(true);
    System.out.println("Oberflaeche main Ende"); 
  }
}

class MyContainer extends Container { // Ein Container nimmt die einzelnen Panele auf
  public MyContainer(Steuerung steu){ 
    System.out.println("MyContainer Konstruktor");   
    setLayout(new BorderLayout(10,10));
    NordPanel nord = new NordPanel(steu);
    SuedPanel sued = new SuedPanel(steu);
    add(nord, BorderLayout.NORTH );
    add(new OstPanel(steu,nord,sued), BorderLayout.EAST );
    add(new MittePanel(steu), BorderLayout.CENTER );
    add(sued, BorderLayout.SOUTH );
    System.out.println("MyContainer Konstruktor Ende");
  } 
}
  
class NordPanel extends JPanel{
  private JTextField dasGeldFeld = new JTextField(5);
  private JButton derEinwurfButton = new JButton("Einwerfen");
  private JLabel dasKassenLabel = new JLabel("0 Cent");
  private Steuerung dieSteuerung; // wir brauchen einen dauerhaften Draht zur Steuerung
  
  public NordPanel(Steuerung steu){
    System.out.println("NordPanel Konstruktor");  
    setBackground(Color.yellow);
    setLayout(new FlowLayout());
    add(new JLabel("Geldeinwurf "));
    add(dasGeldFeld);
    add(derEinwurfButton);
    add(new JLabel("Kasse: "));
    add(dasKassenLabel);
    dieSteuerung = steu;
    derEinwurfButton.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mousePressed(MouseEvent e) {
        int g = Integer.parseInt(dasGeldFeld.getText());
        dasKassenLabel.setText(dieSteuerung.einzahlen(g)+" Cent"); 
      }
    });
    System.out.println("NordPanel Konstruktor Ende");  
  }
  public void anzeigenKasse(){
    dasKassenLabel.setText(dieSteuerung.getKasse()+" Cent");
  }
}
class OstPanel extends JPanel{
  private JLabel dasProduktLabel = new JLabel("Nix");
  private Steuerung dieSteuerung;
  private NordPanel dasNordPanel;
  private SuedPanel dasSuedPanel;
  
  public OstPanel(Steuerung steu, NordPanel nord, SuedPanel sued){
    System.out.println("OstPanel Konstruktor");    
    JButton tmp;
    setBackground(Color.green);
    dieSteuerung = steu;
    dasNordPanel = nord;
    dasSuedPanel = sued;
    setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
    add(Box.createVerticalStrut(20));
    tmp = new JButton("Produkt" + 0);
    add (tmp);
    tmp.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mousePressed(MouseEvent e) {
        klickProdukt(0);
      }
    });
    add(Box.createVerticalStrut(20));
    tmp = new JButton("Produkt" + 1);
    add (tmp);
    tmp.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mousePressed(MouseEvent e) {
        klickProdukt(1);
      }
    });
    add(Box.createVerticalStrut(20));
    tmp = new JButton("Produkt" + 2);
    add (tmp);
    tmp.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mousePressed(MouseEvent e) {
        klickProdukt(2);
      }
    });
    add(Box.createVerticalStrut(20));
    tmp = new JButton("Produkt" + 3);
    add (tmp);
    tmp.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mousePressed(MouseEvent e) {
        klickProdukt(3);
      }
    });
    add(Box.createVerticalGlue());
    add(dasProduktLabel);
    System.out.println("OstPanel Konstruktor Ende");    
  }
  private void klickProdukt(int i){
    int n = dieSteuerung.verkaufe(i);
    if (n < 0) 
      dasProduktLabel.setText("Es fehlen "+-n+" Cent");
    else {
      dasSuedPanel.ausgeben();
      dasProduktLabel.setText("Danke!");
    }    
    dasNordPanel.anzeigenKasse();
  }
}
class MittePanel extends JPanel{
  private JTextArea dieTextArea = new JTextArea(8,20);
  public MittePanel(Steuerung steu){
    System.out.println("MittePanel Konstruktor");    
    String s[]= new String[4];   
    setBackground(Color.white);
    setLayout(new FlowLayout());
    add(dieTextArea);
    dieTextArea.append("Hier eine Übersicht der Produkte\n\n");
    steu.init(s);
    for (int i=0;i<s.length;i++) dieTextArea.append(s[i]+" Cent\t Produkt "+i+"\n\n");
    System.out.println("MittePanel Konstruktor Ende");    
  }
}
class SuedPanel extends JPanel{
  private JTextArea dieAusgabeArea = new JTextArea(8,20);
  private Steuerung dieSteuerung;
  public SuedPanel(Steuerung steu){
    System.out.println("SuedPanel Konstruktor");      
    setBackground(Color.red);
    setLayout(new FlowLayout());
    dieSteuerung = steu;
    add(dieAusgabeArea);
    dieAusgabeArea.append("Ausgabe");
    System.out.println("SuedPanel Konstruktor Ende"); 
  }
  public void ausgeben(){
    String s[]= new String[8];
    dieSteuerung.ausgebenWechselgeld(s);
    dieAusgabeArea.setText("Wechselgeld: \n");
    int i=0;
    while (s[i]!=null)
      dieAusgabeArea.append(s[i++]+"\n");
  }    
}